#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
/* EXO1 */
int input_int(){
  char str[10];
  int i;
  while (1) {
    printf("Entrez un entier : ");
    scanf("%s",str);
    for (i=0; i < strlen(str); i++){
      if (str[i] < '0' || str[i] > '9' || i >=10 ) {
	printf(" Erreur saisie réessayer ! \n");
	break;
      }
    }

    if (i == strlen(str)){
      return atoi(str);
    }
  }
}

/* EXO2 */
int* create_tab (int t){
  int *tab;
  tab = (int*) malloc (t * sizeof (int));
  return tab;
}


/* EXO3 */
void free_tab(int* tab){
  if (tab == NULL)
    return;
  free(tab);
}


/* EXO4 */
void fill_tab (int* tab, int t){
  int i;
  for (i=0; i<t; i++){
    tab[i]=i+1;
  }
}

/* EXO5 */
void display_tab (int* tab, int t){
  int i;
  for (i=0; i<t; i++){
    printf(" %d ", tab[i]);
  }
  printf("\n");
}

/* EXO6 */
void fill_tab_keyboard(int*tab, int t){
int i;
  for (i=0; i<t; i++){
    tab[i]=input_int();
  }  
}


/* EXO7 */
void copy_tab(int* tab1, int* tab2, int t){
  int i;
  for (i=0; i<t; i++){
    tab1[i]=tab2[i];
  }
}


/* EXO8 */
void knuth (int *tab, int t){
  int i;
  int r;
  int tmp;
  srand(time(NULL));
  for(i=t-1 ; i>0 ; i--){
    r = rand() % i;
    tmp = tab[i];
    tab[i] = tab[r];
    tab[r] = tmp;
  }
}


int main(int argc, char *argv[]){

  int size = 10;
  int* tab1;
  int* tab2;
  
  tab1 = create_tab(size);
  fill_tab (tab1,size);
  //fill_tab_keyboard(tab1,size);
  
  tab2 = create_tab(size);
  copy_tab(tab2, tab1, size);
  
  display_tab(tab1,size);
  knuth (tab2,size);
  display_tab(tab2,size);
  
  free_tab(tab1);
  free_tab(tab2);

 
  return 0;
}
